//+------------------------------------------------------------------+
//|                                                   CheckTicks.mq5 |
//|                               Copyright 2020, Vladimir Mikhailov |
//|                                                mikh.vl@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2020, Vladimir Mikhailov"
#property link      "mikh.vl@gmail.com"
#property version   "1.00"
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
//---
   int h=FileOpen("ticks_data", FILE_READ|FILE_BIN);
   uint counter1=0;
   MqlTick collect_ticks[];
   if(h!=INVALID_HANDLE)
      {
       counter1=FileReadArray(h,collect_ticks);
       FileClose(h);
      }
   
   DebugBreak();
  
   MqlTick mql_ticks[];
   uint counter2;
   ulong from_msc=D'2020.01.21 09:45:00';
   ulong to_msc=D'2020.01.22 01:00:00';
   from_msc*=1000;
   to_msc*=1000;
   counter2=CopyTicksRange(_Symbol,mql_ticks,COPY_TICKS_ALL,from_msc,to_msc);
   
   DebugBreak();
  
   string cstr="";
   string mstr="";
   
   int c_counter_256=0;
   int m_counter_256=0;
   uint i=0, j=0;
   
   for(; i<counter1 && j<counter2;)
    {
     cstr="";
     mstr="";
     
     if((collect_ticks[i].flags&B'1')==B'1')cstr+="TICK_FLAG_1|";
     if((collect_ticks[i].flags&TICK_FLAG_BID)==TICK_FLAG_BID)cstr+="TICK_FLAG_BID|";
     if((collect_ticks[i].flags&TICK_FLAG_ASK)==TICK_FLAG_ASK)cstr+="TICK_FLAG_ASK|";
     if((collect_ticks[i].flags&TICK_FLAG_LAST)==TICK_FLAG_LAST)cstr+="TICK_FLAG_LAST|";
     if((collect_ticks[i].flags&TICK_FLAG_VOLUME)==TICK_FLAG_VOLUME)cstr+="TICK_FLAG_VOLUME|";
     if((collect_ticks[i].flags&TICK_FLAG_BUY)==TICK_FLAG_BUY)cstr+="TICK_FLAG_BUY|";
     if((collect_ticks[i].flags&TICK_FLAG_SELL)==TICK_FLAG_SELL)cstr+="TICK_FLAG_SELL|";
     if((collect_ticks[i].flags&B'10000000')==B'10000000')cstr+="TICK_FLAG_128|";
     if((collect_ticks[i].flags&B'100000000')==B'100000000')
      {
       cstr+="TICK_FLAG_256|";
       c_counter_256++;
      }
     if((collect_ticks[i].flags&B'1000000000')==B'1000000000')cstr+="TICK_FLAG_512|";
     if((collect_ticks[i].flags&B'10000000000')==B'10000000000')cstr+="TICK_FLAG_1024|";
     if((collect_ticks[i].flags&B'100000000000')==B'100000000000')cstr+="TICK_FLAG_2048|";
      
     if((mql_ticks[j].flags&B'1')==B'1')mstr+="TICK_FLAG_1|";
     if((mql_ticks[j].flags&TICK_FLAG_BID)==TICK_FLAG_BID)mstr+="TICK_FLAG_BID|";
     if((mql_ticks[j].flags&TICK_FLAG_ASK)==TICK_FLAG_ASK)mstr+="TICK_FLAG_ASK|";
     if((mql_ticks[j].flags&TICK_FLAG_LAST)==TICK_FLAG_LAST)mstr+="TICK_FLAG_LAST|";
     if((mql_ticks[j].flags&TICK_FLAG_VOLUME)==TICK_FLAG_VOLUME)mstr+="TICK_FLAG_VOLUME|";
     if((mql_ticks[j].flags&TICK_FLAG_BUY)==TICK_FLAG_BUY)mstr+="TICK_FLAG_BUY|";
     if((mql_ticks[j].flags&TICK_FLAG_SELL)==TICK_FLAG_SELL)mstr+="TICK_FLAG_SELL|";
     if((mql_ticks[j].flags&B'10000000')==B'10000000')mstr+="TICK_FLAG_128|";
     if((mql_ticks[j].flags&B'100000000')==B'100000000')
      {
       mstr+="TICK_FLAG_256|";
       m_counter_256++;
      }
     if((mql_ticks[j].flags&B'1000000000')==B'1000000000')mstr+="TICK_FLAG_512|";
     if((mql_ticks[j].flags&B'10000000000')==B'10000000000')mstr+="TICK_FLAG_1024|";
     if((mql_ticks[j].flags&B'100000000000')==B'100000000000')mstr+="TICK_FLAG_2048|";
          
     if(collect_ticks[i].time_msc==mql_ticks[j].time_msc)
      {
       i++;
       j++;
      }
     else if(collect_ticks[i].time_msc>mql_ticks[j].time_msc)
      {
       j++;
      }
     else if(collect_ticks[i].time_msc<mql_ticks[j].time_msc)
      {
       i++;
      }
    }
  
   printf("Total collect real ticks: %d; 256 bit tick flag counter: %d; counter i: %d",counter1,c_counter_256,i);
   printf("Total CopyRangeTicks: %d; 256 bit tick flag counter: %d; counter j: %d",counter2,m_counter_256,j);
   
   DebugBreak();
  }
//+------------------------------------------------------------------+
